# Conditional build:
%bcond_without	doc	# API documentation
%bcond_without	tests	# unit tests

%define		module	pyproject-api
Summary:	API to interact with the python pyproject.toml based projects
# Name must match the python module/package name (as on pypi or in 'import' statement)
Name:		python3-%{module}
Version:	1.9.0
Release:	1
License:	MIT
Group:		Libraries/Python
#Source0Download: https://pypi.org/simple/pyproject-api/
Source0:	https://files.pythonhosted.org/packages/source/p/pyproject-api/pyproject_api-%{version}.tar.gz
# Source0-md5:	4ec4e4038061c0a5eb88f9ee4754f809
URL:		https://pypi.org/project/pyproject-api/
BuildRequires:	python3-modules >= 1:3.2
BuildRequires:	python3-build
BuildRequires:	python3-hatch-vcs >= 0.4
BuildRequires:	python3-hatchling >= 1.27
BuildRequires:	python3-installer
%if %{with tests}
BuildRequires:	python3-covdefaults >= 2.3
BuildRequires:	python3-pytest >= 8.3.4
BuildRequires:	python3-pytest-cov >= 6
BuildRequires:	python3-pytest-mock >= 3.14
BuildRequires:	python3-setuptools >= 75.8
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 2.044
%if %{with doc}
BuildRequires:	python3-furo >= 2024.8.6
BuildRequires:	python3-sphinx-autodoc-typehints >= 3
BuildRequires:	python3-tox
%endif
Requires:	python3-modules >= 1:3.2
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
API to interact with the python pyproject.toml based projects.

%package apidocs
Summary:	API documentation for Python %{module} module
Summary(pl.UTF-8):	Dokumentacja API modułu Pythona %{module}
Group:		Documentation

%description apidocs
API documentation for Python %{module} module.

%description apidocs -l pl.UTF-8
Dokumentacja API modułu Pythona %{module}.

%prep
%setup -q -n pyproject_api-%{version}

%build
%py3_build_pyproject

%if %{with tests}
%{__python3} -m zipfile -e build-3/*.whl build-3-test
# use explicit plugins list for reliable builds (delete PYTEST_PLUGINS if empty)
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
PYTEST_PLUGINS="pytest_mock" \
%{__python3} -m pytest -o pythonpath="$PWD/build-3-test" tests
%endif

%if %{with doc}
%{_bindir}/tox -e docs
%endif

%install
rm -rf $RPM_BUILD_ROOT

%py3_install_pyproject

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc README.md
%dir %{py3_sitescriptdir}/pyproject_api
%{py3_sitescriptdir}/pyproject_api/*.py
%{py3_sitescriptdir}/pyproject_api/*.pyi
%{py3_sitescriptdir}/pyproject_api/py.typed
%{py3_sitescriptdir}/pyproject_api/__pycache__
%{py3_sitescriptdir}/pyproject_api-%{version}.dist-info

%if %{with doc}
%files apidocs
%defattr(644,root,root,755)
%doc docs/_build/html/*
%endif
%changelog
* Fri Mar 28 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python3-pyproject-api.git;a=log;h=master

* Fri Mar 28 2025 Jan Rękorajski <baggins@pld-linux.org> a7a84f5
- added description

* Fri Mar 28 2025 Jan Rękorajski <baggins@pld-linux.org> a596f90
- BR hatch-vcs

* Fri Mar 28 2025 Jan Rękorajski <baggins@pld-linux.org> 07a02c5
- drop patch, hatch-vcs is needed

* Fri Mar 28 2025 Jan Rękorajski <baggins@pld-linux.org> 972cc60
- missing patch

* Fri Mar 28 2025 Jan Rękorajski <baggins@pld-linux.org> 3e82170
- ignore vcs deps and fatch failures

* Fri Mar 28 2025 Jan Rękorajski <baggins@pld-linux.org> 1ede1e2
- fix tests

* Fri Mar 28 2025 Jan Rękorajski <baggins@pld-linux.org> 79f135a
- new

